<?php
/**
* @name MOOJ Proforms 
* @version 1.0
* @package proforms
* @copyright Copyright (C) 2008-2010 Mad4Media. All rights reserved.
* @author Dipl. Inf.(FH) Fahrettin Kutyol
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* Please note that some Javascript files are not under GNU/GPL License.
* These files are under the mad4media license
* They may edited and used infinitely but may not repuplished or redistributed.  
* For more information read the header notice of the js files.
**/

defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

remember_cid();
if($id ==-1) die("No ID");

include_once (M4J_INCLUDE_FUNCTIONS);
include_once (M4J_INCLUDE_ELEMENT_HELPER);

//Params
$to = JRequest::getInt("to",0);
$confirmed = JRequest::getInt("confirmed",0);
$address = JRequest::getInt("address",null);
$prio = JRequest::getInt("prio",0);
$time = JRequest::getInt("time",40);
$chunks = JRequest::getInt("chunks",50);
$html_mail = JRequest::getInt("html_mail",1);
$fromname = JRequest::getString("fromname", null);
$from = JRequest::getString("from", null);
$subject = JRequest::getString("subject", null);
$body = JRequest::getString("body", null, 'default', JREQUEST_ALLOWHTML);
$body_no_html = JRequest::getString("body_no_html", null);

$bodyDB = $html_mail ? $body : $body_no_html;


$template_title = JRequest::getString("template_title", null);
$mtid = JRequest::getInt("mtid",null);
$db = & JFactory::getDBO();
switch($task){
	case 'new': 
		MDB::insert('#__m4j_mail_templates', array(
			"title" => $db->getEscaped($template_title),
			"to" => $to,
			"confirmed" => $confirmed,
			"address" => $address,
			"prio" => $prio,
			"time" => $time,
			"chunks" => $chunks,
			"html_mail" => $html_mail,
			"fromname" => $db->getEscaped($fromname),
			"from" => $db->getEscaped($from),
			"subject" => $db->getEscaped($subject),
			"body" => $db->getEscaped($bodyDB)
		));		
		break;
		
	case 'update': 
		if($mtid){
			MDB::update('#__m4j_mail_templates', array(
				"title" => $db->getEscaped($template_title),
				"to" => $to,
				"confirmed" => $confirmed,
				"address" => $address,
				"prio" => $prio,
				"time" => $time,
				"chunks" => $chunks,
				"html_mail" => $html_mail,
				"fromname" => $db->getEscaped($fromname),
				"from" => $db->getEscaped($from),
				"subject" => $db->getEscaped($subject),
				"body" => $db->getEscaped($bodyDB)
			), MDB::_("mtid",$mtid));	
		}	
		break;
	case 'delete': 
		if($mtid){
			MDB::delete('#__m4j_mail_templates','mtid',$mtid);
		}
		break;
	case 'get': 
		
		if($mtid){
			$mailTemplate = MDB::get('#__m4j_mail_templates',null,MDB::_("mtid",$mtid),"LIMIT 1");
			if($mailTemplate && sizeof($mailTemplate) == 1){
				$mt = $mailTemplate[0];
				
				$to = $mt->to;
				$confirmed = $mt->confirmed;
				$address = $mt->address;
				$prio = $mt->prio;
				$time = $mt->time;
				$chunks = $mt->chunks;
				$html_mail = $mt->html_mail;
				$fromname = $mt->fromname;
				$from = $mt->from;
				$subject = $mt->subject;
				$body = $mt->body;
				$body_no_html = $mt->body;
				
				$template_title = $mt->title;
				$mtid = $mt->mtid;
			}
		}
		break;
}




$query = $db->setQuery("
	SELECT * FROM `#__m4j_jobs` WHERE `jid` = '$id' LIMIT 1
");
$form = $db->loadObject();


$u = & JFactory::getURI();
$selfURI = $u->toString();

$document->addScriptDeclaration('
	
		var selfURI = \''.$selfURI.'\';

		var mailText = {
			NOFROMNAME : "'.M4J_LANG_NOFROMNAME.'",
			NOFROM : "'.M4J_LANG_NOFROMMAIL.'",
			NOVALIDEMAIL : "'.M4J_LANG_NOVALIDFROMADDRESS.'",
			NOSUBJECT : "'.M4J_LANG_NO_SUBJECT.'",
			SENDING_CANCELED : "'.M4J_LANG_SENDING_CANCELED.'",
			SENDING_SUCCESS : "'.M4J_LANG_MAIL_SENDING_END.'",
			SENDINGCHUNKS : "'.M4J_LANG_SENDING_CHUNK.'",
			SENT : "'.M4J_LANG_SENT.'",
			FAILED : "'.M4J_LANG_FAILED.'",
			NOEMAILMATCH : "'.M4J_LANG_NOVALIDADDRESS.'"
		};
		
		var mtListURI = "'.M4J_LOAD_XHR.'mail_templates";
		
		var XHRALIAS = "'.M4J_LOAD_XHR.'mail_alias&fids='.$form->fid.'";
		
		var M4J_IMAGES = "'.M4J_IMAGES.'";
		
		var XHRMAILCOUNT = "'.M4J_LOAD_XHR.'mail_count";
		
		var XHRMAILCHUNK = "'.M4J_LOAD_XHR.'mail_chunk";
				
');

$document->addScript(M4J_JS.'storage_mail.js');







$elements = new ElementHelper($id);
$elementItems = $elements->getElements();
$unique = $elements->getUnique();
?>

<div style="display:block; ">

<form name="m4jMailForm" id="m4jMailForm" action="<?php echo $selfURI; ?>" method="post" target="">

	<input type="hidden" name="jid" value="<?php echo $id; ?>" ></input>
	<input type="hidden" name="fid" value="<?php echo $form->fid; ?>" ></input>
	<textarea style="display:none;" name="search" id="searchBox"></textarea>
	<input type="hidden" name="col" value="" id="searchIn"></input>
	<input type="hidden" name="optinfilter" value="" id="optInFilter"></input>

	<input type="hidden" name="task" value="" id="task"></input>
	<input type="hidden" name="mtid" value="" id="mtid"></input>
	<input type="hidden" name="start" value="" id="start"></input>
	<input type="hidden" name="totalcount" value="" id="totalcount"></input>
	

	<div style="display:block; position: relative; float:left; width: 730px; margin:0; padding:0; border: 1px solid #d0d0d0; margin-right: 10px; height: 580px;">		
		<div style="display:block; margin:0; padding:0;  padding-left:10px; color:black; background-color: #F0F0F0; border-bottom: 1px solid #d0d0d0; height: 24px; line-height: 24px; font-size: 12px; font-weight: bold;">
			<img src="<?php echo M4J_IMAGES;?>mail_24.png" align="top" style="margin-right: 10px;"/>
			<?php echo M4J_LANG_STORAGE_MAIL_HEADING; ?>: <span style="color:blue;"><?php echo $form->title; ?></span>
			<div class="startSending" id="startSending" onclick="javascript: startSending();" ><span><?php echo M4J_LANG_SEND; ?></span></div>
		</div>
		
		<div style="padding: 10px;">
		
			<fieldset style="width: 500px; float:left;">
				<legend><?php echo M4J_LANG_STORAGE_MAIL_DESTINATION; ?></legend>
				<div style="float:left;">
					<label><?php echo M4J_LANG_TO; ?>:</label> 
					<?php 
						$toArray = array(
							array("val"=> 0 , "text"=> M4J_LANG_ALL_RECORDS),
							array("val"=> 1 , "text"=> M4J_LANG_FILTERED_RECORDS)
						);
						echo MForm::select(
							"to",
							$toArray,
							$to,
							MFORM_DROP_DOWN,
							null,
							'style="" id="to"'
						);
					
					?>
				</div>
				
				<div style="float:right; margin-right: 10px; line-height: 17px;">
					<label style="float:left; margin-right: 10px; "><?php echo M4J_LANG_MAIL_ONLY_CONFIRMED; ?>: </label>
					<?php echo MForm::specialCheckbox("confirmed", $confirmed); ?>
				</div>
				
				<div class="m4jCLR"></div>	
				<br/>
				<div style="float:left;">
					<label><?php echo M4J_LANG_MAIL_ADDRESS_IS; ?>:</label> 
					<select id="address"  name="address" style="width: 400px;">
						<optgroup label="Proforms/Joomla" >
						<?php if($unique):?>
							<option value="0"<?php _isSelected(0,$address); ?>><?php echo M4J_LANG_UNIQUE_OF_FORM; ?></option>
						<?php endif;?>
							<option value="-1"<?php _isSelected(-1,$address); ?>><?php echo M4J_LANG_USER_MAIL_ADDRESS; ?></option>
						</optgroup>
						<optgroup label="<?php echo M4J_LANG_FIELD_ITEM; ?>">
						<?php foreach($elementItems as $element){ 
							$fieldLabel = $element->question ?  _chopString($element->question,50) :  _chopString($element->alias,50);
						?>
							<option value="<?php echo $element->eid; ?>" <?php _isSelected($element->eid,$address); ?>><?php echo $fieldLabel;?></option>		
						<?php } ?>
						</optgroup>
									
					</select>
				</div>
			</fieldset>
			<div style="float:right;">
				<a class="midButton" style="margin-top:6px;" onclick="javascript: showSaveToTemplate(); return false;"><?php echo M4J_LANG_SAVE_AS_TEMPLATE; ?></a>
				<a class="midButton" style="margin-top:6px;" onclick="javascript: showGetFromTemplate(); return false;" ><?php echo M4J_LANG_GET_FROM_TEMPLATE; ?></a>
			
			</div>
			<div class="m4jCLR"></div>
			
			
			<fieldset>
				<legend><?php echo M4J_LANG_SENDING_CONDITIONS; ?></legend>
				<table cellpadding="0" cellspacing="0" border="0"><tbody><tr>
					<td> 
					<?php echo M4J_LANG_PRIO; ?>:
					</td>
					<td> 
					<?php 
						$prioArray = array(
							array("val"=> 0 , "text"=> M4J_LANG_NORMAL),
							array("val"=> 1 , "text"=> M4J_LANG_HIGH)
						);
						echo MForm::select(
							"prio",
							$prioArray,
							$prio,
							MFORM_DROP_DOWN,
							null,
							'style="margin-left: 5px;" id="prio"'
						);
					
					?>
					</td>
					<td style="width: 10px;"></td>					
					<td> 
					<?php echo M4J_LANG_SENDING_INTERVAL; ?>:
					</td>
					<td> 
					<?php 
					$allowedIntervals = array(5,10,15,20,25,30,35,40,45,50,55,60,90,120);
					$intervalArray = array();
					foreach($allowedIntervals as $interval){
						array_push($intervalArray,array("val"=> $interval, "text"=> $interval." ".M4J_LANG_SECONDS));
					}
					
					
					echo MForm::select(
						"time",
						$intervalArray,
						$time,
						MFORM_DROP_DOWN,
						null,
						'style="margin-left: 5px;" id="time"'
						);
					
					?>
					</td>
					<td style="width: 10px;"></td>	
					<td> 
					<?php echo M4J_LANG_MAILS_AT_ONCE; ?>:
					</td>
					<td>
						<?php 
					$allowedChunks= array(1,2,5,10,25,50,100,200,500);
					$chunkArray = array();
					foreach($allowedChunks as $chunk){
						array_push($chunkArray,array("val"=> $chunk, "text"=> $chunk));
					}
					
					
					echo MForm::select(
						"chunks",
						$chunkArray,
						$chunks,
						MFORM_DROP_DOWN,
						null,
						'style="width: 45px; margin-left: 5px;" id="chunks"'
						);
					
					?>
					</td>
					<td style="width: 10px;"></td>	
					<td> 
					<?php echo M4J_LANG_HTML_MAIL; ?>
					</td>
					<td> 
						<div style="margin-left: 5px;">
						<?php echo MForm::specialCheckbox("html_mail", $html_mail,"m4jToggleActive",0,"toggleMailEditor();"); ?>
						</div>
					</td>
					<td>
						<img info="<?php echo M4J_LANG_BODY_TOGGLE_DESC; ?>" src="<?php echo M4J_IMAGES;?>info.png" align="top" style="margin-left: 10px;"/>
					</td>
				</tr></tbody></table>
			</fieldset>
			
			<div style="margin-bottom: 10px;">
				<table cellspacing="0" cellpadding="0" border="0" width="100%" ><tbody>
				<tr>
					<td style="width: 100px;"><span style="margin-right: 10px;"><?php echo M4J_LANG_FROMNAME; ?>:</span></td>
					<td><input type="text" name="fromname" value="<?php echo $fromname; ?>" id="fromname" style="width: 225px;"></input></td>
					<td style="width: 100px;" align="right"><span style="margin-right: 10px;"><?php echo M4J_LANG_FROMMAIL?>:</span> </td>
					<td style="width: 225px;"><input type="text" name="from" value="<?php echo $from; ?>" id="from" style="width: 225px;"></input></td>
				
				</tr>
				<tr><td colspan="4" height="10px"></td></tr>
				<tr>
					<td><label style="display:block; width:80px; float:left; "><?php echo M4J_LANG_SUBJECT; ?>:</label></td>
					<td colspan="3"> 
						<input type="text" id="subject" name="subject" value="<?php echo $subject;?>" style="width: 415px; float:left;"></input>
					
					<a class="m4jMailAliasButton" onclick="javascript: toggleAliases(); return false;">
						<?php echo M4J_LANG_INSERT_FIELD_VALUE; ?>					
					</a>
					<img onclick="javascript: toggleAliases(); return false;" id="mtAliasX" class="m4jMailAliasButtonIcon" style="display:none;" src="<?php echo M4J_IMAGES;?>remove.png" />
					<img onclick="javascript: toggleAliases(); return false;" id="mtAliasPlus" class="m4jMailAliasButtonIcon" src="<?php echo M4J_IMAGES;?>add12.png" />
					
					
					</td>
				</tr>
				</tbody></table>
			</div>
			
			<textarea style="display:<?php echo $html_mail ? "none" : "block" ; ?>; width:100%; height: 300px;" name="body_no_html" id="bodyNoHTML"><?php echo $body_no_html; ?></textarea>
			<div id="bodyHTML" style= "display: <?php echo $html_mail ? "block" : "none" ; ?>;">
				<?php  MEditorArea('body',$body,'body','100%','300','75','30'); ?>
			</div>
			
			<br/>
		</div>
		
		
		<!-- EMAIL SENDING PANEL -->
		
		<div style="display:none;" id="sendingPanel"> 
			<div style="padding:10px;">
				<div style="background-color: #ffefef; border: 1px solid #F47373; min-height: 150px; color: #000;">
					<div style="padding:10px;">
					<span style="font-size: 16px; font-weight: bold;"><?php echo M4J_LANG_SENDING_BEGUN; ?></span>
					
					<ul>
						<li><?php echo M4J_LANG_SENDING_ADVICE_1; ?></li>
						<li><?php echo M4J_LANG_SENDING_ADVICE_2; ?></li>
						<li><?php echo M4J_LANG_SENDING_ADVICE_3; ?></li>
						<li><?php echo M4J_LANG_SENDING_ADVICE_4; ?></li>
						<li><?php echo M4J_LANG_SENDING_ADVICE_5; ?></li>
					</ul>
					
					</div>
				</div>
				<div style="display:block; margin-top: 10px; font-size: 16px; font-weight: bold;">
					<?php echo M4J_LANG_FOUND_STORAGE_ITEMS; ?>: <span id="storageCount"></span>
					<span id="mailSendingEnd" style="float:right; color:green; margin-right: 10px; display:none;"></span>
				</div>
				
				<span style="display:block; margin-top: 10px; font-size: 16px; font-weight: bold;"><?php echo M4J_LANG_PROTOCOL; ?>:</span>
				
				
				<div style="background-color: #fff; border: 1px solid #D0D0D0; height: 300px; color: #000; overflow-x:hidden; overflow-y: auto;">
					<div style="padding:10px;" id="m4jSendingInfo"></div>
				</div>
				
					<a id="closeSendingButton" class="midButton" style="margin-top:6px; float:right; display:none;" onclick="javascript: closeSending(); return false;" >
						<?php echo M4J_LANG_CLOSE; ?>
					</a>
			
				
				
				
			</div>
		</div>
		
		<!-- EOF EMAIL SENDING PANEL -->
		
		<!-- SAVE TO TEMPLATE PANEL -->
		
		<div style="display:<?php echo ($task=="delete") ? "block" : "none" ; ?>;" id="saveToTemplate"> 
			<div style="padding:10px;">
			<div style="display:block; margin-bottom: 10px; font-size: 16px; font-weight: bold;"><?php echo M4J_LANG_SAVE_AS_TEMPLATE; ?></div>
			
			<fieldset>
				<legend style="font-size: 14px; color:black; "><?php echo JText::_("New"); ?></legend>
				<label style="font-size: 14px; margin-left: 3px;"><?php echo JText::_("Title"); ?></label>	
				<input type="text" name="template_title" value="<?php echo $template_title; ?>" style="margin-left:5px; width: 450px; height:16px; font-size: 14px;"></input>
				
				<a onclick="javascript: return saveNewMailTemplate();" class="m4jSelect m4jMailSelect" >
					<span style="font-size: 12px; padding-top: 3px;" class="m4jSelectExtend"><?php echo M4J_LANG_SAVE; ?></span>
				</a>

			</fieldset>
				
			<div style="display:block; margin-top: 10px; font-size: 16px; font-weight: bold;"><?php echo M4J_LANG_OVERWRITE_DELETE; ?>:</div>	
				
			<div style="background-color: #fff; border: 1px solid #D0D0D0; height: 400px; color: #000; overflow-x:hidden; overflow-y: auto;">
					<div style="padding:10px;" id="mtList">
					</div>
			</div>	
				
				<a onclick="javascript: closeSaveToTemplate(); return false;" style="margin-top: 10px; width: 100px;float:right;" class="m4jSelect m4jSelectDisabled" >
					<div style="font-size: 12px; padding-top: 3px;" class="m4jSelectExtend"><?php echo M4J_LANG_CANCEL; ?></div>
				</a>
				
			</div>
		</div>
		
		<!-- EOF SAVE TO TEMPLATE PANEL -->
		
		
		<!-- GET FROM TEMPLATE PANEL -->
		
		<div style="display:none;" id="getFromTemplate"> 
			<div style="padding:10px;">
			<div style="display:block; margin-bottom: 10px; font-size: 16px; font-weight: bold;"><?php echo M4J_LANG_GET_FROM_TEMPLATE; ?></div>
			
			<div style="background-color: #fff; border: 1px solid #D0D0D0; height: 480px; color: #000; overflow-x:hidden; overflow-y: auto;">
					<div style="padding:10px;" id="mtGetList">
					</div>
			</div>	
				
				<a onclick="javascript: closeGetFromTemplate(); return false;" style="margin-top: 10px; width: 100px;float:right;" class="m4jSelect m4jSelectDisabled" >
					<div style="font-size: 12px; padding-top: 3px;" class="m4jSelectExtend"><?php echo M4J_LANG_CANCEL; ?></div>
				</a>
				
			</div>
		</div>
		
		<!-- EOF GET FROM TEMPLATE PANEL -->
		
		
		
	</div>

</form>
<!-- END OF FORM  -->

	<div style="position: relative; display:block; float:right; width: 180px; margin:0; padding:0; border: 1px solid #d0d0d0; height: 548px;">
		<div style="display:block; margin:0; padding:0;  padding-left:10px; color:black; background-color: #F0F0F0; border-bottom: 1px solid #d0d0d0; height: 24px; line-height: 24px; font-size: 12px; font-weight: bold;">
			<?php echo M4J_LANG_PROGRESS; ?>: <span id="progress">100</span>% 
			<span class="redButton mailCancelButton" id="cancelMail"  onclick="javascript: cancelSending();" style="display:none;">
				<span>
					<span><?php echo M4J_LANG_CANCEL; ?></span>
				</span>
			</span>
		</div>
		
		<div class="mailIFrameWrap" id="iframeWrap"></div>	
			
		<div style="display: none;" class="mailFormFieldsWrap" id="mailAliases">
		</div>	
	</div>
	
	<a class="m4jMailImportantInfo" onclick="javascript: mWindow.container.innerHTML = dojo.byId('importantInfoContent').innerHTML; mWindow.open({width: 640, height: 480});">
		<span>
		<img src="<?php echo M4J_IMAGES; ?>info.png" align="top" />
		<?php echo M4J_LANG_IMPORTANT_INFO;?>
		</span>
	</a>
	
	
<div class="m4jCLR"></div>	

</div>	


<div id="importantInfoContent" style="display:none;">
	<div style="padding:16px;">
		<h1><?php echo M4J_LANG_IMPORTANT_INFO; ?></h1>
		<span style="font-size:14px; line-height: 150%;">
		<?php echo M4J_LANG_IMPORTANT_INFO_INNER;?>
		</span>
	</div>
</div>


<?php 
echo'
  <script type="text/javascript" src="'.M4J_JS.'proforms-footer.js"></script>
  <script type="text/javascript" src="'.M4J_JS_INFO.'"></script>
  <script type="text/javascript" src="'.M4J_JS.'parsing.js"></script>
';
?>

<?php 
//echo "<pre>";
//print_r($elements);
//echo "</pre>";


?>
